var express = require('express')
var serve = require('serve-browserify')
var browserify = require('browserify')
var assign = require('lodash.assign')
var defined = require('defined')
var Cacher = require('cacher')
var Path = require('path')

module.exports = serveBundle

function serveBundle (config) {
  var app = express()

  var b = browserify(assign({}, serve.args, {
   entries: [Path.join(__dirname, '..', 'client.js')],
   debug: config.bundle.debug
  }))

  if (config.bundle.minify) {
    b.transform({
      global: true 
    }, require('uglifyify'))
  }

  if (config.bundle.cache) {
    var cacheLength = defined(config.bundle.cacheLength, 'days')
    var cacher = new Cacher()
    app.use(cacher.cache(cacheLength))
  }

  app.get('/bundle.js', serve(b, {
   cacheFile: Path.join(__dirname, '..', '..', '.cache', 'bundle.json')
  }))

  return app
}
